/*
 * game_ground.cc
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#include "game_ground.h"

#define DEBUG 0
#include "debug.h"

void GTrava::step(void) {
	if (damage > 0)
		damage--;
}

GSymbol* GTrava::draw(void) {
	struct {
		char symbol;
		int color;
	} symbol_table[] = {
		{ '.',  2 },
		{ ':',  6 },
		{ 'u',  6 },
		{ 'u',  6 },
		{ '\0', 0 }
	};
	return new GSymbol(symbol_table[damage / 300].symbol,
			symbol_table[damage / 300].color,
			pos_x, pos_y, pos_z);
}

