/*
 * game_world.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#ifndef JK_GAME_WORLD_H
#define JK_GAME_WORLD_H

#include <list>

#include "ref.h"
#include "game_object.h"
#include "game_beast.h"
#include "game_ground.h"

#define KEY_NUM		4

class GameWorld : public GObject, public Ref {
	public:
		GameWorld(int width, int height);
		~GameWorld(void);

		/** jeden krok casu
		 */
		void step(void);
		
		/* renderovani sveta? */
		GSymbol *draw(void) { return NULL; };

		/** info o hre
		 * RET: 1 ... jo, konec
		 * 	0 ... nene, jeste se bude blbnout dal.
		 */
		int is_game_over(void);

		/** ziskavani kecu od objektu
		 * RET: postupne co objekty rikaly
		 * 	na konci NULL
		 */
		//char* get_message();
		int get_score_krtek(void) { return krtek ? krtek->get_property(GOP_SCORE) : -1; };
		int get_score_zahradnik(void) { return zahradnik ? zahradnik->get_property(GOP_SCORE) : -1; };

		void interpret_keys(int key[KEY_NUM]);
	private:
		GKrtek *krtek;
		GZahradnik *zahradnik;

};

#endif

