/*
 * ref.cc
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */

#include <stdio.h>

#include "ref.h"

#define DEBUG 0
#include "debug.h"

Ref::Ref(void) {
	this->ref_count = 1;
	DBG_MSG(8, "Ref::Ref: Ref created; ref = %d", this->ref_count);
}

Ref::~Ref(void) {
}

void Ref::ref(void) {
	this->ref_count++;
	DBG_MSG(8, "Ref::ref: ref_count = %d", ref_count);
}

void Ref::unref(void) {
	if (!--this->ref_count) {
		DBG_MSG(8, "Ref::unref: Destroying message.");
		delete this;
	} else {
		DBG_MSG(8, "Ref::unref: ref_count = %d", ref_count);
	}
}

