/*
 * sample_msg.cc
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sample_msg.h"

#define DEBUG 0
#include "debug.h"

SampleMsg::SampleMsg(int size) {
	if (!(this->data = (s_data *) malloc(sizeof(s_data) * size)))
		perror("SampleMSG: malloc:");
	bzero(this->data, sizeof(s_data) * size);

	if (!(this->freq = (int *) malloc(sizeof(int) * size)))
		perror("SampleMSG: malloc:");
	bzero(this->freq, sizeof(int) * size);
	this->size = size;
	
	DBG_MSG(8, "SampleMsg::SampleMsg: Message created: size = %d", this->size);
}

SampleMsg::~SampleMsg(void) {
	if (this->data)
		free(this->data);
	if (this->freq)
		free(this->freq);
}

void SampleMsg::sort_by_val(void) {
	qsort(this->data, this->size, sizeof(s_data), freq_val_compare);
}

int freq_val_compare(const void *a, const void *b) {
	SampleMsg::s_data *aa = (SampleMsg::s_data *) a;
        SampleMsg::s_data *bb = (SampleMsg::s_data *) b;
        float res = (aa->val - bb->val);
	const float tolerance = 0.8;

        if (res > tolerance)
                return -1;
        else if (res < -tolerance)
                return 1;
        else
                return 0;

}

