/*
 * sample_msg.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */

#include "ref.h"

#ifndef JK_SAMPLE_MSG_H
#define JK_SAMPLE_MSG_H

class SampleMsg : public Ref {
	public:
		SampleMsg(int size);
		~SampleMsg(void);

		int size;
		struct s_data {
			int val;
			int freq;
		} *data;

		int *freq;
		long intensity;

		void sort_by_val(void);

	private:
		
	friend int freq_val_compare(const void *a, const void *b);
};

#endif
